import bpy
import math

# by Chaos with Stackexchange help XD
# get keyframes of object list
def get_keyframes(obj_list):
    keyframes = []
    for obj in obj_list:
        anim = obj.animation_data
        if anim is not None and anim.action is not None:
            for fcu in anim.action.fcurves:
                for keyframe in fcu.keyframe_points:
                    x, y = keyframe.co
                    if x not in keyframes:
                        keyframes.append((math.ceil(x)))
    return sorted(set(keyframes))

# get all selected objects
selection = bpy.context.selected_objects

# check if selection is not empty
if selection:

    # get all frames with assigned keyframes
    keys = get_keyframes(selection)

    # print all keyframes
    print (keys)   

    # print first and last keyframe
    print ("{} {}".format("first keyframe:", keys[0]))
    print ("{} {}".format("last keyframe:", keys[-1]))

else:
    print ('nothing selected')
    
# get the current scene
scn = bpy.context.scene 

# assign new starting frame
scn.frame_start = keys[0]

# assign new end frame
scn.frame_end = keys[-1]


# reset transform for the resetboneLiest
arm = bpy.data.objects['skeleton.nif']

allBonelist = ["NPC Root [Root]", "x_NPC LookNode [Look]", "x_NPC Translate [Pos ]", "x_NPC Rotate [Rot ]", "NPC COM [COM ]", "NPC Pelvis [Pelv]", 
"NPC Thigh [Thg].L", "NPC Calf [Clf].L", "NPC Foot [ft ].L", "NPC Thigh [Thg].R", "NPC Calf [Clf].R", "NPC Foot [ft ].R", 
"SkirtRBone01", "SkirtRBone02", "SkirtRBone03", "SkirtLBone01", "SkirtLBone02", "SkirtLBone03", 
"SkirtBBone01", "SkirtBBone02", "SkirtBBone03", "SkirtFBone01", "SkirtFBone02", "SkirtFBone03", 
"NPC Spine [Spn0]", "NPC Spine1 [Spn1]", "NPC Spine2 [Spn2]", "NPC Clavicle [Clv].L", 
"NPC UpperArm [Uar].L", "NPC Forearm [Lar].L", "NPC Clavicle [Clv].R", 
"NPC UpperArm [Uar].R", "NPC Forearm [Lar].R", "AnimObjectA", "AnimObjectB", "NPC Neck [Neck]", "NPC Head [Head]", "NPCEyeBone", "NPC Hand [Hnd].L", 
"NPC Hand [Hnd].R", "AnimObjectL", "AnimObjectR", "SHIELD", "WEAPON", "NPC L Pauldron", "NPC R Pauldron", 
"MagicEffectsNode", "NPC MagicNode [Mag].L", "NPC MagicNode [Mag].R", "NPC Head MagicNode [Hmag]", "NPC Toe0 [Toe].L", "NPC Toe0 [Toe].R", 
"NPC ForearmTwist1 [Lt1].L", "NPC ForearmTwist2 [Lt2].L", "NPC UpperarmTwist1 [Ut1].L", "NPC UpperarmTwist2 [Ut2].L", 
"NPC ForearmTwist1 [Lt1].R", "NPC ForearmTwist2 [Lt2].R", "NPC UpperarmTwist1 [Ut1].R", "NPC UpperarmTwist2 [Ut2].R", "QUIVER", 
"WeaponAxe", "WeaponBack", "WeaponBow", "WeaponDagger", "WeaponMace", "WeaponSword", "NPC Finger00 [F00].L", 
"NPC Finger01 [F01].L", "NPC Finger02 [F02].L", "NPC Finger10 [F10].L", "NPC Finger11 [F11].L", 
"NPC Finger12 [F12].L", "NPC Finger20 [F20].L", "NPC Finger21 [F21].L", "NPC Finger22 [F22].L", 
"NPC Finger30 [F30].L", "NPC Finger31 [F31].L", "NPC Finger32 [F32].L", "NPC Finger40 [F40].L", 
"NPC Finger41 [F41].L","NPC Finger42 [F42].L", "NPC Finger00 [F00].R", "NPC Finger01 [F01].R", 
"NPC Finger02 [F02].R", "NPC Finger10 [F10].R", "NPC Finger11 [F11].R", "NPC Finger12 [F12].R", 
"NPC Finger20 [F20].R", "NPC Finger21 [F21].R", "NPC Finger22 [F22].R", "NPC Finger30 [F30].R", "NPC Finger31 [F31].R", "NPC Finger32 [F32].R", 
"NPC Finger40 [F40].R", "NPC Finger41 [F41].R", "NPC Finger42 [F42].R", "Camera3rd [Cam3]", "Camera Control"]


for n in allBonelist:
     if n in arm.pose.bones:
        arm.pose.bones[n].keyframe_insert("rotation_quaternion", frame=keys[0])
        arm.pose.bones[n].keyframe_insert("location", frame=keys[0])
        arm.pose.bones[n].keyframe_insert("rotation_quaternion", frame=keys[-1])
        arm.pose.bones[n].keyframe_insert("location", frame=keys[-1])
        arm.pose.bones[n].keyframe_insert("scale", frame=keys[0])
        arm.pose.bones[n].keyframe_insert("scale", frame=keys[-1])

def ShowMessageBox(message = "", title = "Message Box", icon = 'INFO'):

    def draw(self, context):
        self.layout.label(text=message)

    bpy.context.window_manager.popup_menu(draw, title = title, icon = icon)


#Shows a message box with a message and custom title
ShowMessageBox("Fix Nodes", "DONE")