from generated.base_enum import BaseEnum
from generated.formats.nif.basic import Uint


class Fallout3HavokMaterial(BaseEnum):

	"""
	Bethesda Havok. Material descriptor for a Havok shape in Fallout 3 and Fallout NV.
	"""

	__name__ = 'Fallout3HavokMaterial'
	_storage = Uint


	# Stone
	FO_HAV_MAT_STONE = 0

	# Cloth
	FO_HAV_MAT_CLOTH = 1

	# Dirt
	FO_HAV_MAT_DIRT = 2

	# Glass
	FO_HAV_MAT_GLASS = 3

	# Grass
	FO_HAV_MAT_GRASS = 4

	# Metal
	FO_HAV_MAT_METAL = 5

	# Organic
	FO_HAV_MAT_ORGANIC = 6

	# Skin
	FO_HAV_MAT_SKIN = 7

	# Water
	FO_HAV_MAT_WATER = 8

	# Wood
	FO_HAV_MAT_WOOD = 9

	# Heavy Stone
	FO_HAV_MAT_HEAVY_STONE = 10

	# Heavy Metal
	FO_HAV_MAT_HEAVY_METAL = 11

	# Heavy Wood
	FO_HAV_MAT_HEAVY_WOOD = 12

	# Chain
	FO_HAV_MAT_CHAIN = 13

	# Bottlecap
	FO_HAV_MAT_BOTTLECAP = 14

	# Elevator
	FO_HAV_MAT_ELEVATOR = 15

	# Hollow Metal
	FO_HAV_MAT_HOLLOW_METAL = 16

	# Sheet Metal
	FO_HAV_MAT_SHEET_METAL = 17

	# Sand
	FO_HAV_MAT_SAND = 18

	# Broken Concrete
	FO_HAV_MAT_BROKEN_CONCRETE = 19

	# Vehicle Body
	FO_HAV_MAT_VEHICLE_BODY = 20

	# Vehicle Part Solid
	FO_HAV_MAT_VEHICLE_PART_SOLID = 21

	# Vehicle Part Hollow
	FO_HAV_MAT_VEHICLE_PART_HOLLOW = 22

	# Barrel
	FO_HAV_MAT_BARREL = 23

	# Bottle
	FO_HAV_MAT_BOTTLE = 24

	# Soda Can
	FO_HAV_MAT_SODA_CAN = 25

	# Pistol
	FO_HAV_MAT_PISTOL = 26

	# Rifle
	FO_HAV_MAT_RIFLE = 27

	# Shopping Cart
	FO_HAV_MAT_SHOPPING_CART = 28

	# Lunchbox
	FO_HAV_MAT_LUNCHBOX = 29

	# Baby Rattle
	FO_HAV_MAT_BABY_RATTLE = 30

	# Rubber Ball
	FO_HAV_MAT_RUBBER_BALL = 31

	# Stone
	FO_HAV_MAT_STONE_PLATFORM = 32

	# Cloth
	FO_HAV_MAT_CLOTH_PLATFORM = 33

	# Dirt
	FO_HAV_MAT_DIRT_PLATFORM = 34

	# Glass
	FO_HAV_MAT_GLASS_PLATFORM = 35

	# Grass
	FO_HAV_MAT_GRASS_PLATFORM = 36

	# Metal
	FO_HAV_MAT_METAL_PLATFORM = 37

	# Organic
	FO_HAV_MAT_ORGANIC_PLATFORM = 38

	# Skin
	FO_HAV_MAT_SKIN_PLATFORM = 39

	# Water
	FO_HAV_MAT_WATER_PLATFORM = 40

	# Wood
	FO_HAV_MAT_WOOD_PLATFORM = 41

	# Heavy Stone
	FO_HAV_MAT_HEAVY_STONE_PLATFORM = 42

	# Heavy Metal
	FO_HAV_MAT_HEAVY_METAL_PLATFORM = 43

	# Heavy Wood
	FO_HAV_MAT_HEAVY_WOOD_PLATFORM = 44

	# Chain
	FO_HAV_MAT_CHAIN_PLATFORM = 45

	# Bottlecap
	FO_HAV_MAT_BOTTLECAP_PLATFORM = 46

	# Elevator
	FO_HAV_MAT_ELEVATOR_PLATFORM = 47

	# Hollow Metal
	FO_HAV_MAT_HOLLOW_METAL_PLATFORM = 48

	# Sheet Metal
	FO_HAV_MAT_SHEET_METAL_PLATFORM = 49

	# Sand
	FO_HAV_MAT_SAND_PLATFORM = 50

	# Broken Concrete
	FO_HAV_MAT_BROKEN_CONCRETE_PLATFORM = 51

	# Vehicle Body
	FO_HAV_MAT_VEHICLE_BODY_PLATFORM = 52

	# Vehicle Part Solid
	FO_HAV_MAT_VEHICLE_PART_SOLID_PLATFORM = 53

	# Vehicle Part Hollow
	FO_HAV_MAT_VEHICLE_PART_HOLLOW_PLATFORM = 54

	# Barrel
	FO_HAV_MAT_BARREL_PLATFORM = 55

	# Bottle
	FO_HAV_MAT_BOTTLE_PLATFORM = 56

	# Soda Can
	FO_HAV_MAT_SODA_CAN_PLATFORM = 57

	# Pistol
	FO_HAV_MAT_PISTOL_PLATFORM = 58

	# Rifle
	FO_HAV_MAT_RIFLE_PLATFORM = 59

	# Shopping Cart
	FO_HAV_MAT_SHOPPING_CART_PLATFORM = 60

	# Lunchbox
	FO_HAV_MAT_LUNCHBOX_PLATFORM = 61

	# Baby Rattle
	FO_HAV_MAT_BABY_RATTLE_PLATFORM = 62

	# Rubber Ball
	FO_HAV_MAT_RUBBER_BALL_PLATFORM = 63

	# Stone
	FO_HAV_MAT_STONE_STAIRS = 64

	# Cloth
	FO_HAV_MAT_CLOTH_STAIRS = 65

	# Dirt
	FO_HAV_MAT_DIRT_STAIRS = 66

	# Glass
	FO_HAV_MAT_GLASS_STAIRS = 67

	# Grass
	FO_HAV_MAT_GRASS_STAIRS = 68

	# Metal
	FO_HAV_MAT_METAL_STAIRS = 69

	# Organic
	FO_HAV_MAT_ORGANIC_STAIRS = 70

	# Skin
	FO_HAV_MAT_SKIN_STAIRS = 71

	# Water
	FO_HAV_MAT_WATER_STAIRS = 72

	# Wood
	FO_HAV_MAT_WOOD_STAIRS = 73

	# Heavy Stone
	FO_HAV_MAT_HEAVY_STONE_STAIRS = 74

	# Heavy Metal
	FO_HAV_MAT_HEAVY_METAL_STAIRS = 75

	# Heavy Wood
	FO_HAV_MAT_HEAVY_WOOD_STAIRS = 76

	# Chain
	FO_HAV_MAT_CHAIN_STAIRS = 77

	# Bottlecap
	FO_HAV_MAT_BOTTLECAP_STAIRS = 78

	# Elevator
	FO_HAV_MAT_ELEVATOR_STAIRS = 79

	# Hollow Metal
	FO_HAV_MAT_HOLLOW_METAL_STAIRS = 80

	# Sheet Metal
	FO_HAV_MAT_SHEET_METAL_STAIRS = 81

	# Sand
	FO_HAV_MAT_SAND_STAIRS = 82

	# Broken Concrete
	FO_HAV_MAT_BROKEN_CONCRETE_STAIRS = 83

	# Vehicle Body
	FO_HAV_MAT_VEHICLE_BODY_STAIRS = 84

	# Vehicle Part Solid
	FO_HAV_MAT_VEHICLE_PART_SOLID_STAIRS = 85

	# Vehicle Part Hollow
	FO_HAV_MAT_VEHICLE_PART_HOLLOW_STAIRS = 86

	# Barrel
	FO_HAV_MAT_BARREL_STAIRS = 87

	# Bottle
	FO_HAV_MAT_BOTTLE_STAIRS = 88

	# Soda Can
	FO_HAV_MAT_SODA_CAN_STAIRS = 89

	# Pistol
	FO_HAV_MAT_PISTOL_STAIRS = 90

	# Rifle
	FO_HAV_MAT_RIFLE_STAIRS = 91

	# Shopping Cart
	FO_HAV_MAT_SHOPPING_CART_STAIRS = 92

	# Lunchbox
	FO_HAV_MAT_LUNCHBOX_STAIRS = 93

	# Baby Rattle
	FO_HAV_MAT_BABY_RATTLE_STAIRS = 94

	# Rubber Ball
	FO_HAV_MAT_RUBBER_BALL_STAIRS = 95

	# Stone
	FO_HAV_MAT_STONE_STAIRS_PLATFORM = 96

	# Cloth
	FO_HAV_MAT_CLOTH_STAIRS_PLATFORM = 97

	# Dirt
	FO_HAV_MAT_DIRT_STAIRS_PLATFORM = 98

	# Glass
	FO_HAV_MAT_GLASS_STAIRS_PLATFORM = 99

	# Grass
	FO_HAV_MAT_GRASS_STAIRS_PLATFORM = 100

	# Metal
	FO_HAV_MAT_METAL_STAIRS_PLATFORM = 101

	# Organic
	FO_HAV_MAT_ORGANIC_STAIRS_PLATFORM = 102

	# Skin
	FO_HAV_MAT_SKIN_STAIRS_PLATFORM = 103

	# Water
	FO_HAV_MAT_WATER_STAIRS_PLATFORM = 104

	# Wood
	FO_HAV_MAT_WOOD_STAIRS_PLATFORM = 105

	# Heavy Stone
	FO_HAV_MAT_HEAVY_STONE_STAIRS_PLATFORM = 106

	# Heavy Metal
	FO_HAV_MAT_HEAVY_METAL_STAIRS_PLATFORM = 107

	# Heavy Wood
	FO_HAV_MAT_HEAVY_WOOD_STAIRS_PLATFORM = 108

	# Chain
	FO_HAV_MAT_CHAIN_STAIRS_PLATFORM = 109

	# Bottlecap
	FO_HAV_MAT_BOTTLECAP_STAIRS_PLATFORM = 110

	# Elevator
	FO_HAV_MAT_ELEVATOR_STAIRS_PLATFORM = 111

	# Hollow Metal
	FO_HAV_MAT_HOLLOW_METAL_STAIRS_PLATFORM = 112

	# Sheet Metal
	FO_HAV_MAT_SHEET_METAL_STAIRS_PLATFORM = 113

	# Sand
	FO_HAV_MAT_SAND_STAIRS_PLATFORM = 114

	# Broken Concrete
	FO_HAV_MAT_BROKEN_CONCRETE_STAIRS_PLATFORM = 115

	# Vehicle Body
	FO_HAV_MAT_VEHICLE_BODY_STAIRS_PLATFORM = 116

	# Vehicle Part Solid
	FO_HAV_MAT_VEHICLE_PART_SOLID_STAIRS_PLATFORM = 117

	# Vehicle Part Hollow
	FO_HAV_MAT_VEHICLE_PART_HOLLOW_STAIRS_PLATFORM = 118

	# Barrel
	FO_HAV_MAT_BARREL_STAIRS_PLATFORM = 119

	# Bottle
	FO_HAV_MAT_BOTTLE_STAIRS_PLATFORM = 120

	# Soda Can
	FO_HAV_MAT_SODA_CAN_STAIRS_PLATFORM = 121

	# Pistol
	FO_HAV_MAT_PISTOL_STAIRS_PLATFORM = 122

	# Rifle
	FO_HAV_MAT_RIFLE_STAIRS_PLATFORM = 123

	# Shopping Cart
	FO_HAV_MAT_SHOPPING_CART_STAIRS_PLATFORM = 124

	# Lunchbox
	FO_HAV_MAT_LUNCHBOX_STAIRS_PLATFORM = 125

	# Baby Rattle
	FO_HAV_MAT_BABY_RATTLE_STAIRS_PLATFORM = 126

	# Rubber Ball
	FO_HAV_MAT_RUBBER_BALL_STAIRS_PLATFORM = 127
